/*
 *  Copyright (C) 2010, 2011, 2012 Michael Hofmann, Chemnitz University of Technology
 *  
 *  This file is part of the Sorting Library.
 *  
 *  The Sorting Library is free software: you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  The Sorting Library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  

 *  
 *  SL - Sorting Library, michael <dot> hofmann <at> informatik <dot> tu-chemnitz <dot> de
 */


#ifndef __DASH_RENAME_H__
#define __DASH_RENAME_H__


#define DS_CONCAT(_a_, _b_)           DS_CONCAT_(_a_, _b_)
#define DS_CONCAT_(_a_, _b_)          _a_##_b_

#define DS_CONCONCAT(_a_, _b_, _c_)   DS_CONCONCAT_(_a_, _b_, _c_)
#define DS_CONCONCAT_(_a_, _b_, _c_)  _a_##_b_##_c_

#ifdef DS_PREFIX
# define DS_VAR(_v_)   DS_CONCAT(DS_PREFIX, _v_)
# define DS_FUNC(_f_)  DS_CONCAT(DS_PREFIX, _f_)
#else
# define DS_VAR(_v_)   _v_
# define DS_FUNC(_f_)  _f_
#endif


/* src/base_mpi/dash_aux_static.c */
#define ds_aux_static_create  DS_FUNC(ds_aux_static_create)
#define ds_aux_static_destroy  DS_FUNC(ds_aux_static_destroy)
#define ds_aux_static_acquire  DS_FUNC(ds_aux_static_acquire)
#define ds_aux_static_get_count  DS_FUNC(ds_aux_static_get_count)
#define ds_aux_static_get_displ  DS_FUNC(ds_aux_static_get_displ)
#define ds_aux_static_vacate  DS_FUNC(ds_aux_static_vacate)
#define ds_aux_static_accept_recv  DS_FUNC(ds_aux_static_accept_recv)

/* src/base_mpi/dash_core.c */
#define ds_core_run_sync  DS_VAR(ds_core_run_sync)
#define ds_times  DS_VAR(ds_times)
#define ds_create  DS_FUNC(ds_create)
#define ds_destroy  DS_FUNC(ds_destroy)
#define ds_print  DS_FUNC(ds_print)
#define ds_run  DS_FUNC(ds_run)
#define ds_sched_add_buffer  DS_FUNC(ds_sched_add_buffer)
#define ds_sched_set_send  DS_FUNC(ds_sched_set_send)
#define ds_sched_set_recv  DS_FUNC(ds_sched_set_recv)
#define ds_sched_set_aux  DS_FUNC(ds_sched_set_aux)
#define ds_exec_add_address  DS_FUNC(ds_exec_add_address)

/* src/base_mpi/dash_exec.c */
#define ds_exec_make_sym  DS_FUNC(ds_exec_make_sym)
#define ds_exec_make  DS_FUNC(ds_exec_make)

/* src/base_mpi/dash_exec_sl.c */
#define ds_exec_sl_create  DS_FUNC(ds_exec_sl_create)
#define ds_exec_sl_destroy  DS_FUNC(ds_exec_sl_destroy)
#define ds_exec_sl_pre_run  DS_FUNC(ds_exec_sl_pre_run)
#define ds_exec_sl_post_run  DS_FUNC(ds_exec_sl_post_run)
#define ds_exec_sl_make  DS_FUNC(ds_exec_sl_make)
#define ds_exec_sl_add_address  DS_FUNC(ds_exec_sl_add_address)
#define ds_exec_sl_move  DS_FUNC(ds_exec_sl_move)

/* src/base_mpi/dash_sched_a2av.c */
#define ds_sched_a2av_aux_blocks  DS_VAR(ds_sched_a2av_aux_blocks)
#define ds_sched_a2av_create  DS_FUNC(ds_sched_a2av_create)
#define ds_sched_a2av_destroy  DS_FUNC(ds_sched_a2av_destroy)
#define ds_sched_a2av_set_aux  DS_FUNC(ds_sched_a2av_set_aux)
#define ds_sched_a2av_max_n  DS_FUNC(ds_sched_a2av_max_n)
#define ds_sched_a2av_pre_run  DS_FUNC(ds_sched_a2av_pre_run)
#define ds_sched_a2av_post_run  DS_FUNC(ds_sched_a2av_post_run)
#define ds_sched_a2av_finished  DS_FUNC(ds_sched_a2av_finished)
#define ds_add_aux_recv_request  DS_FUNC(ds_add_aux_recv_request)
#define ds_vacate_aux  DS_FUNC(ds_vacate_aux)
#define ds_sched_a2av_pre  DS_FUNC(ds_sched_a2av_pre)
#define ds_sched_a2av_post  DS_FUNC(ds_sched_a2av_post)
#define ds_compare_displs  DS_FUNC(ds_compare_displs)
#define ds_compare_begins  DS_FUNC(ds_compare_begins)

/* src/base_mpi/dash_sched_a2av_aux.c */
#define ds_aux_create  DS_FUNC(ds_aux_create)
#define ds_aux_destroy  DS_FUNC(ds_aux_destroy)
#define ds_aux_pre_acquire  DS_FUNC(ds_aux_pre_acquire)
#define ds_aux_acquire  DS_FUNC(ds_aux_acquire)
#define ds_aux_post_acquire  DS_FUNC(ds_aux_post_acquire)
#define ds_aux_get_count  DS_FUNC(ds_aux_get_count)
#define ds_aux_get_displ  DS_FUNC(ds_aux_get_displ)
#define ds_aux_vacate  DS_FUNC(ds_aux_vacate)
#define ds_aux_accept_recv  DS_FUNC(ds_aux_accept_recv)


#endif /* __DASH_RENAME_H__ */
