/*
 *  Copyright (C) 2010, 2011, 2012 Michael Hofmann, Chemnitz University of Technology
 *  
 *  This file is part of the Sorting Library.
 *  
 *  The Sorting Library is free software: you can redistribute it and/or
 *  modify it under the terms of the GNU Lesser Public License as published
 *  by the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *  
 *  The Sorting Library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU Lesser Public License for more details.
 *  
 *  You should have received a copy of the GNU Lesser Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *  

 *  
 *  SL - Sorting Library, michael <dot> hofmann <at> informatik <dot> tu-chemnitz <dot> de
 */


#ifndef __SPEC_PUBLIC_H__
#define __SPEC_PUBLIC_H__


/* sp_macro SPEC_PROC_NULL */


/* sp_macro SPEC_DECLARE_TPROC_COUNT_DB */
#define SPEC_DECLARE_TPROC_COUNT_DB \
  spint_t spec0cd_i, spec0cd_p;

/* sp_macro SPEC_DO_TPROC_COUNT_DB */
#define SPEC_DO_TPROC_COUNT_DB(_tp_, _tpd_, _b_, _cs_)  do { \
  for (spec0cd_i = 0; spec0cd_i < spec_elem_get_n(_b_); ++spec0cd_i) { \
    spec0cd_p = (_tp_)(spec_elem_get_buf(_b_), spec0cd_i, _tpd_); \
    if (spec0cd_p == SPEC_PROC_NULL) continue; \
    ++(_cs_)[spec0cd_p]; \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROC_COUNT_DB */
#define SPEC_FUNC_TPROC_COUNT_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tproc_count_db(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts) \
{ \
   SPEC_DECLARE_TPROC_COUNT_DB \
   SPEC_DO_TPROC_COUNT_DB(_tp_, tproc_data, s, counts); \
}

/* sp_macro SPEC_DECLARE_TPROC_COUNT_IP */
#define SPEC_DECLARE_TPROC_COUNT_IP \
  spint_t spec0ci_i, spec0ci_p, spec0ci_t;

/* sp_macro SPEC_DO_TPROC_COUNT_IP */
#define SPEC_DO_TPROC_COUNT_IP(_tp_, _tpd_, _b_, _cs_)  do { \
  spec0ci_t = 0; \
  for (spec0ci_i = 0; spec0ci_i < spec_elem_get_n(_b_); ++spec0ci_i) { \
    spec0ci_p = (_tp_)(spec_elem_get_buf(_b_), spec0ci_i, _tpd_); \
    if (spec0ci_p == SPEC_PROC_NULL) continue; \
    ++(_cs_)[spec0ci_p]; \
    if (spec0ci_t < spec0ci_i) spec_elem_copy_at((_b_), spec0ci_i, (_b_), spec0ci_t); \
    ++spec0ci_t; \
  } \
  spec_elem_set_n(_b_, spec0ci_t); \
} while (0)

/* sp_macro SPEC_FUNC_TPROC_COUNT_IP */
#define SPEC_FUNC_TPROC_COUNT_IP(_name_, _tp_, _s_...) \
_s_ void _name_##_tproc_count_ip(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts) \
{ \
   SPEC_DECLARE_TPROC_COUNT_IP \
   SPEC_DO_TPROC_COUNT_IP(_tp_, tproc_data, s, counts); \
}

/* sp_macro SPEC_DECLARE_TPROCS_COUNT_DB */
#define SPEC_DECLARE_TPROCS_COUNT_DB \
  spint_t spec1cd_i, spec1cd_j, spec1cd_n;

/* sp_macro SPEC_DO_TPROCS_COUNT_DB */
#define SPEC_DO_TPROCS_COUNT_DB(_tp_, _tpd_, _b_, _cs_, _ps_)  do { \
  for (spec1cd_i = 0; spec1cd_i < spec_elem_get_n(_b_); ++spec1cd_i) { \
    spec1cd_n = (_tp_)(spec_elem_get_buf(_b_), spec1cd_i, (_tpd_), (_ps_)); \
    for (spec1cd_j = 0; spec1cd_j < spec1cd_n; ++spec1cd_j) ++(_cs_)[(_ps_)[spec1cd_j]]; \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_COUNT_DB */
#define SPEC_FUNC_TPROCS_COUNT_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_count_db(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_COUNT_DB \
   SPEC_DO_TPROCS_COUNT_DB(_tp_, tproc_data, s, counts, procs); \
}

/* sp_macro SPEC_DECLARE_TPROCS_COUNT_IP */
#define SPEC_DECLARE_TPROCS_COUNT_IP \
  spint_t spec1ci_i, spec1ci_j, spec1ci_n, spec1ci_t;

/* sp_macro SPEC_DO_TPROCS_COUNT_IP */
#define SPEC_DO_TPROCS_COUNT_IP(_tp_, _tpd_, _b_, _cs_, _ps_)  do { \
  spec1ci_t = 0; \
  for (spec1ci_i = 0; spec1ci_i < spec_elem_get_n(_b_); ++spec1ci_i) { \
    spec1ci_n = (_tp_)(spec_elem_get_buf(_b_), spec1ci_i, (_tpd_), (_ps_)); \
    if (spec1ci_n <= 0) continue; \
    for (spec1ci_j = 0; spec1ci_j < spec1ci_n; ++spec1ci_j) ++(_cs_)[(_ps_)[spec1ci_j]]; \
    if (spec1ci_t < spec1ci_i) spec_elem_copy_at((_b_), spec1ci_i, (_b_), spec1ci_t); \
    ++spec1ci_t; \
  } \
  spec_elem_set_n(_b_, spec1ci_t); \
} while (0)

/* sp_macro SPEC_FUNC_TPROCS_COUNT_IP */
#define SPEC_FUNC_TPROCS_COUNT_IP(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_count_ip(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_COUNT_IP \
   SPEC_DO_TPROCS_COUNT_IP(_tp_, tproc_data, s, counts, procs); \
}

/* sp_macro SPEC_DECLARE_TPROCS_DUP_COUNT_DB */
#define SPEC_DECLARE_TPROCS_DUP_COUNT_DB \
  spint_t spec2cd_i, spec2cd_j, spec2cd_n;

/* sp_macro SPEC_DO_TPROCS_DUP_COUNT_DB */
#define SPEC_DO_TPROCS_DUP_COUNT_DB(_tp_, _tpd_, _b_, _cs_, _ps_)  do { \
  for (spec2cd_i = 0; spec2cd_i < spec_elem_get_n(_b_); ++spec2cd_i) \
  { \
    spec2cd_n = (_tp_)(spec_elem_get_buf(_b_), spec2cd_i, (_tpd_), (_ps_), NULL); \
    for (spec2cd_j = 0; spec2cd_j < spec2cd_n; ++spec2cd_j) ++(_cs_)[(_ps_)[spec2cd_j]]; \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_DUP_COUNT_DB */
#define SPEC_FUNC_TPROCS_DUP_COUNT_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_dup_count_db(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_DUP_COUNT_DB \
   SPEC_DO_TPROCS_DUP_COUNT_DB(_tp_, tproc_data, s, counts, procs); \
}

/* sp_macro SPEC_DECLARE_TPROCS_DUP_COUNT_IP */
#define SPEC_DECLARE_TPROCS_DUP_COUNT_IP \
  spint_t spec2ci_i, spec2ci_j, spec2ci_n, spec2ci_t;

/* sp_macro SPEC_DO_TPROCS_DUP_COUNT_IP */
#define SPEC_DO_TPROCS_DUP_COUNT_IP(_tp_, _tpd_, _b_, _cs_, _ps_)  do { \
  spec2ci_t = 0; \
  for (spec2ci_i = 0; spec2ci_i < spec_elem_get_n(_b_); ++spec2ci_i) { \
    spec2ci_n = (_tp_)(spec_elem_get_buf(_b_), spec2ci_i, (_tpd_), (_ps_), NULL); \
    if (spec2ci_n <= 0) continue; \
    for (spec2ci_j = 0; spec2ci_j < spec2ci_n; ++spec2ci_j) ++(_cs_)[(_ps_)[spec2ci_j]]; \
    if (spec2ci_t < spec2ci_i) spec_elem_copy_at((_b_), spec2ci_i, (_b_), spec2ci_t); \
    ++spec2ci_t; \
  } \
  spec_elem_set_n(_b_, spec2ci_t); \
} while (0)

/* sp_macro SPEC_FUNC_TPROCS_DUP_COUNT_IP */
#define SPEC_FUNC_TPROCS_DUP_COUNT_IP(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_dup_count_ip(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_DUP_COUNT_IP \
   SPEC_DO_TPROCS_DUP_COUNT_IP(_tp_, tproc_data, s, counts, procs); \
}

/* sp_macro SPEC_DECLARE_TPROC_REARRANGE_DB */
#define SPEC_DECLARE_TPROC_REARRANGE_DB \
  spint_t spec0d_i, spec0d_p;

/* sp_macro SPEC_DO_TPROC_REARRANGE_DB */
#define SPEC_DO_TPROC_REARRANGE_DB(_tp_, _tpd_, _sb_, _db_, _ds_)  do { \
  for (spec0d_i = 0; spec0d_i < spec_elem_get_n(_sb_); ++spec0d_i) { \
    spec0d_p = (_tp_)(spec_elem_get_buf(_sb_), spec0d_i, _tpd_); \
    if (spec0d_p == SPEC_PROC_NULL) continue; \
    spec_elem_copy_at((_sb_), spec0d_i, (_db_), (_ds_)[spec0d_p]); \
    ++(_ds_)[spec0d_p]; \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROC_REARRANGE_DB */
#define SPEC_FUNC_TPROC_REARRANGE_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tproc_rearrange_db(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs) \
{ \
   SPEC_DECLARE_TPROC_REARRANGE_DB \
   SPEC_DO_TPROC_REARRANGE_DB(_tp_, tproc_data, s, d, displs); \
}

/* sp_macro SPEC_DECLARE_TPROC_REARRANGE_IP */
#define SPEC_DECLARE_TPROC_REARRANGE_IP \
  spint_t spec0i_e, spec0i_i, spec0i_j, spec0i_p, spec0i_np;

/* sp_macro SPEC_DO_TPROC_REARRANGE_IP */
#define SPEC_DO_TPROC_REARRANGE_IP(_tp_, _tpd_, _b_, _xb_, _ds_, _cs_, _n_)  do { \
  for (spec0i_e = 0, spec0i_i = 0; spec0i_i < (_n_); ++spec0i_i) { \
    spec0i_e += (_cs_)[spec0i_i]; \
    spec0i_j = (_ds_)[spec0i_i]; \
    while (spec0i_j < spec0i_e) { \
      spec0i_p = (_tp_)(spec_elem_get_buf(_b_), spec0i_j, _tpd_); \
      while (spec0i_p != spec0i_i) { \
        spec0i_np = (_tp_)(spec_elem_get_buf(_b_), (_ds_)[spec0i_p], _tpd_); \
        if (spec0i_np != spec0i_p) spec_elem_exchange_at((_b_), (_ds_)[spec0i_p], (_b_), spec0i_j, (_xb_)); \
        ++(_ds_)[spec0i_p]; \
        spec0i_p = spec0i_np; \
      } \
      ++spec0i_j; \
    } \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROC_REARRANGE_IP */
#define SPEC_FUNC_TPROC_REARRANGE_IP(_name_, _tp_, _s_) \
_s_ void _name_##_tproc_rearrange_ip(spec_elem_t *s, spec_elem_t *x, spec_tproc_data_t tproc_data, int *displs, int *counts, int n) \
{ \
   SPEC_DECLARE_TPROC_REARRANGE_IP \
   SPEC_DO_TPROC_REARRANGE_IP(_tp_, tproc_data, s, x, displs, counts, n); \
}

/* sp_macro SPEC_DECLARE_TPROCS_REARRANGE_DB */
#define SPEC_DECLARE_TPROCS_REARRANGE_DB \
  spint_t spec1d_i, spec1d_j, spec1d_n;

/* sp_macro SPEC_DO_TPROCS_REARRANGE_DB */
#define SPEC_DO_TPROCS_REARRANGE_DB(_tp_, _tpd_, _sb_, _db_, _ds_, _ps_)  do { \
  for (spec1d_i = 0; spec1d_i < spec_elem_get_n(_sb_); ++spec1d_i) { \
    spec1d_n = (_tp_)(spec_elem_get_buf(_sb_), spec1d_i, (_tpd_), (_ps_)); \
    for (spec1d_j = 0; spec1d_j < spec1d_n; ++spec1d_j) { \
      spec_elem_copy_at((_sb_), spec1d_i, (_db_), (_ds_)[(_ps_)[spec1d_j]]); \
      ++(_ds_)[(_ps_)[spec1d_j]]; \
    } \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_REARRANGE_DB */
#define SPEC_FUNC_TPROCS_REARRANGE_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_rearrange_db(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_REARRANGE_DB \
   SPEC_DO_TPROCS_REARRANGE_DB(_tp_, tproc_data, s, d, displs, procs); \
}

/* sp_macro SPEC_DECLARE_TPROCS_REARRANGE_IP */
#define SPEC_DECLARE_TPROCS_REARRANGE_IP \
  spint_t spec1i_e, spec1i_i, spec1i_j, spec1i_n, spec1i_f, spec1i_o;

/* sp_macro SPEC_DO_TPROCS_REARRANGE_IP */
#define SPEC_DO_TPROCS_REARRANGE_IP(_tp_, _tpd_, _b_, _xb_, _ds_, _cs_, _n_, _ps_)  do { \
  spec1i_f = (_ds_)[_n_] + (_cs_)[_n_]; \
  for (spec1i_e = 0, spec1i_i = 0; spec1i_i < (_n_); ++spec1i_i) { \
    spec1i_e += (_cs_)[spec1i_i]; \
    spec1i_j = (_ds_)[spec1i_i]; \
    while (spec1i_j < spec1i_e) { \
      spec1i_n = (_tp_)(spec_elem_get_buf(_b_), spec1i_j, (_tpd_), (_ps_)); \
      spec1i_o = -1; \
      while (spec1i_n > 1) { \
        --spec1i_n; \
        if ((_ps_)[spec1i_n] == spec1i_e) { spec1i_o = spec1i_n; continue; } \
        spec_elem_copy_at((_b_), (_ds_)[(_ps_)[spec1i_n]], (_b_), spec1i_f); \
        spec_elem_copy_at((_b_), spec1i_j, (_b_), (_ds_)[(_ps_)[spec1i_n]]); \
        ++spec1i_f; \
        ++(_ds_)[(_ps_)[spec1i_n]]; \
      } \
      if (spec1i_o >= 0) { \
        spec_elem_copy_at((_b_), (_ds_)[(_ps_)[0]], (_b_), spec1i_f); \
        spec_elem_copy_at((_b_), spec1i_j, (_b_), (_ds_)[(_ps_)[0]]); \
        ++spec1i_f; \
        ++spec1i_j; \
      } else { \
        if ((_ps_)[0] != spec1i_i) spec_elem_exchange_at((_b_), spec1i_j, (_b_), (_ds_)[(_ps_)[0]], (_xb_)); \
        else ++spec1i_j; \
      } \
      ++(_ds_)[(_ps_)[0]]; \
    } \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_REARRANGE_IP */
#define SPEC_FUNC_TPROCS_REARRANGE_IP(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_rearrange_ip(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs, int *counts, int n, int *procs) \
{ \
   SPEC_DECLARE_TPROCS_REARRANGE_IP \
   SPEC_DO_TPROCS_REARRANGE_IP(_tp_, tproc_data, s, d, displs, counts, n, procs); \
}

/* sp_macro SPEC_DECLARE_TPROCS_DUP_REARRANGE_DB */
#define SPEC_DECLARE_TPROCS_DUP_REARRANGE_DB \
  spint_t spec2d_i, spec2d_j, spec2d_n;

/* sp_macro SPEC_DO_TPROCS_DUP_REARRANGE_DB */
#define SPEC_DO_TPROCS_DUP_REARRANGE_DB(_tp_, _tpd_, _sb_, _db_, _ds_, _ps_, _ib_)  do { \
  if (_ib_) { \
    for (spec2d_i = 0; spec2d_i < spec_elem_get_n(_sb_); ++spec2d_i) { \
      spec2d_n = (_tp_)(spec_elem_get_buf(_sb_), spec2d_i, (_tpd_), (_ps_), spec_elem_get_buf(_ib_)); \
      for (spec2d_j = 0; spec2d_j < spec2d_n; ++spec2d_j) { \
        spec_elem_copy_at((_ib_), spec2d_j, (_db_), (_ds_)[(_ps_)[spec2d_j]]); \
        ++(_ds_)[(_ps_)[spec2d_j]]; \
      } \
    } \
  } else { \
    for (spec2d_i = 0; spec2d_i < spec_elem_get_n(_sb_); ++spec2d_i) { \
      spec2d_n = (_tp_)(spec_elem_get_buf(_sb_), spec2d_i, (_tpd_), (_ps_), NULL); \
      for (spec2d_j = 0; spec2d_j < spec2d_n; ++spec2d_j) { \
        spec_elem_copy_at((_sb_), spec2d_i, (_db_), (_ds_)[(_ps_)[spec2d_j]]); \
        ++(_ds_)[(_ps_)[spec2d_j]]; \
      } \
    } \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_DUP_REARRANGE_DB */
#define SPEC_FUNC_TPROCS_DUP_REARRANGE_DB(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_dup_rearrange_db(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs, int *procs, spec_elem_t *dups) \
{ \
   SPEC_DECLARE_TPROCS_DUP_REARRANGE_DB \
   SPEC_DO_TPROCS_DUP_REARRANGE_DB(_tp_, tproc_data, s, d, displs, procs, dups); \
}

/* sp_macro SPEC_DECLARE_TPROCS_DUP_REARRANGE_IP */
#define SPEC_DECLARE_TPROCS_DUP_REARRANGE_IP \
  spint_t spec2i_e, spec2i_i, spec2i_j, spec2i_n, spec2i_f, spec2i_o;

/* sp_macro SPEC_DO_TPROCS_DUP_REARRANGE_IP */
#define SPEC_DO_TPROCS_DUP_REARRANGE_IP(_tp_, _tpd_, _b_, _xb_, _ds_, _cs_, _n_, _ps_, _ib_)  do { \
  if (_ib_) { \
    spec2i_f = (_ds_)[_n_] + (_cs_)[_n_]; \
    for (spec2i_e = 0, spec2i_i = 0; spec2i_i < (_n_); ++spec2i_i) { \
      spec2i_e += (_cs_)[spec2i_i]; \
      spec2i_j = (_ds_)[spec2i_i]; \
      while (spec2i_j < spec2i_e) { \
        spec2i_n = (_tp_)(spec_elem_get_buf(_b_), spec2i_j, (_tpd_), (_ps_), spec_elem_get_buf(_ib_)); \
        spec2i_o = -1; \
        while (spec2i_n > 1) { \
          --spec2i_n; \
          if ((_ps_)[spec2i_n] == spec2i_e) { spec2i_o = spec2i_n; continue; } \
          spec_elem_copy_at((_b_), (_ds_)[(_ps_)[spec2i_n]], (_b_), spec2i_f); \
          spec_elem_copy_at((_ib_), spec2i_n, (_b_), (_ds_)[(_ps_)[spec2i_n]]); \
          ++spec2i_f; \
          ++(_ds_)[(_ps_)[spec2i_n]]; \
        } \
        if (spec2i_o >= 0) { \
          spec_elem_copy_at((_b_), (_ds_)[(_ps_)[0]], (_b_), spec2i_f); \
          spec_elem_copy_at((_ib_), 0, (_b_), (_ds_)[(_ps_)[0]]); \
          spec_elem_copy_at((_ib_), spec2i_o, (_b_), spec2i_j); \
          ++spec2i_f; \
          ++spec2i_j; \
        } else { \
          if ((_ps_)[0] != spec2i_i) spec_elem_copy_at((_b_), (_ds_)[(_ps_)[0]], (_b_), spec2i_j); \
          else ++spec2i_j; \
          spec_elem_copy_at((_ib_), 0, (_b_), (_ds_)[(_ps_)[0]]); \
        } \
        ++(_ds_)[(_ps_)[0]]; \
      } \
    } \
  } else { \
    spec2i_f = (_ds_)[_n_] + (_cs_)[_n_]; \
    for (spec2i_e = 0, spec2i_i = 0; spec2i_i < (_n_); ++spec2i_i) { \
      spec2i_e += (_cs_)[spec2i_i]; \
      spec2i_j = (_ds_)[spec2i_i]; \
      while (spec2i_j < spec2i_e) { \
        spec2i_n = (_tp_)(spec_elem_get_buf(_b_), spec2i_j, (_tpd_), (_ps_), NULL); \
        spec2i_o = -1; \
        while (spec2i_n > 1) { \
          --spec2i_n; \
          if ((_ps_)[spec2i_n] == spec2i_e) { spec2i_o = spec2i_n; continue; } \
          spec_elem_copy_at((_b_), (_ds_)[(_ps_)[spec2i_n]], (_b_), spec2i_f); \
          spec_elem_copy_at((_b_), spec2i_j, (_b_), (_ds_)[(_ps_)[spec2i_n]]); \
          ++spec2i_f; \
          ++(_ds_)[(_ps_)[spec2i_n]]; \
        } \
        if (spec2i_o >= 0) { \
          spec_elem_copy_at((_b_), (_ds_)[(_ps_)[0]], (_b_), spec2i_f); \
          spec_elem_copy_at((_b_), spec2i_j, (_b_), (_ds_)[(_ps_)[0]]); \
          ++spec2i_f; \
          ++spec2i_j; \
        } else { \
          if ((_ps_)[0] != spec2i_i) spec_elem_exchange_at((_b_), spec2i_j, (_b_), (_ds_)[(_ps_)[0]], (_xb_)); \
          else ++spec2i_j; \
        } \
        ++(_ds_)[(_ps_)[0]]; \
      } \
    } \
  } } while (0)

/* sp_macro SPEC_FUNC_TPROCS_DUP_REARRANGE_IP */
#define SPEC_FUNC_TPROCS_DUP_REARRANGE_IP(_name_, _tp_, _s_...) \
_s_ void _name_##_tprocs_dup_rearrange_ip(spec_elem_t *s, spec_elem_t *x, spec_tproc_data_t tproc_data, int *displs, int *counts, int n, int *procs, spec_elem_t *dups) \
{ \
   SPEC_DECLARE_TPROCS_DUP_REARRANGE_IP \
   SPEC_DO_TPROCS_DUP_REARRANGE_IP(_tp_, tproc_data, s, x, displs, counts, n, procs, dups); \
}

/* sp_macro SPEC_DEFINE_TPROC */
#define SPEC_DEFINE_TPROC(_name_, _tp_, _s_...) \
  SPEC_FUNC_TPROC_COUNT_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROC_COUNT_IP(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROC_REARRANGE_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROC_REARRANGE_IP(_name_, _tp_, _s_)

/* sp_macro SPEC_DEFINE_TPROCS */
#define SPEC_DEFINE_TPROCS(_name_, _tp_, _s_...) \
  SPEC_FUNC_TPROCS_COUNT_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_COUNT_IP(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_REARRANGE_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_REARRANGE_IP(_name_, _tp_, _s_)

/* sp_macro SPEC_DEFINE_TPROCS_DUP */
#define SPEC_DEFINE_TPROCS_DUP(_name_, _tp_, _s_...) \
  SPEC_FUNC_TPROCS_DUP_COUNT_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_DUP_COUNT_IP(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_DUP_REARRANGE_DB(_name_, _tp_, _s_) \
  SPEC_FUNC_TPROCS_DUP_REARRANGE_IP(_name_, _tp_, _s_)

/* sp_macro SPEC_EXT_PARAM_TPROC SPEC_EXT_PARAM_TPROC_NULL SPEC_EXT_PARAM_TPROCS SPEC_EXT_PARAM_TPROCS_NULL SPEC_EXT_PARAM_TPROCS_DUP SPEC_EXT_PARAM_TPROCS_DUP_NULL */
#define SPEC_EXT_PARAM_TPROC(_name_)       _name_##_tproc_count_db, _name_##_tproc_count_ip, _name_##_tproc_rearrange_db, _name_##_tproc_rearrange_ip
#define SPEC_EXT_PARAM_TPROC_NULL          NULL, NULL, NULL, NULL
#define SPEC_EXT_PARAM_TPROCS(_name_)      _name_##_tprocs_count_db, _name_##_tprocs_count_ip, _name_##_tprocs_rearrange_db, _name_##_tprocs_rearrange_ip
#define SPEC_EXT_PARAM_TPROCS_NULL         NULL, NULL, NULL, NULL
#define SPEC_EXT_PARAM_TPROCS_DUP(_name_)  _name_##_tprocs_dup_count_db, _name_##_tprocs_dup_count_ip, _name_##_tprocs_dup_rearrange_db, _name_##_tprocs_dup_rearrange_ip
#define SPEC_EXT_PARAM_TPROCS_DUP_NULL     NULL, NULL, NULL, NULL


/* sp_type spec_tproc_f spec_tproc_count_f spec_tproc_rearrange_db_f spec_tproc_rearrange_ip_f */
typedef int spec_tproc_f(spec_elem_buf_t b, spec_elem_index_t x, spec_tproc_data_t tproc_data);
typedef void spec_tproc_count_f(spec_elem_t *s, spec_tproc_data_t tproc_data, int *counts);
typedef void spec_tproc_rearrange_db_f(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs);
typedef void spec_tproc_rearrange_ip_f(spec_elem_t *s, spec_elem_t *x, spec_tproc_data_t tproc_data, int *displs, int *counts, int n);

/* sp_type spec_tprocs_f spec_tprocs_count_f spec_tprocs_rearrange_db_f spec_tprocs_rearrange_ip_f */
typedef int spec_tprocs_f(spec_elem_buf_t b, spec_elem_index_t x, spec_tproc_data_t tproc_data, int *procs);
typedef void spec_tprocs_count_f(spec_elem_t *s, spec_tproc_data_t tproc_data, int *procs, int *counts);
typedef void spec_tprocs_rearrange_db_f(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs, int *procs);
typedef void spec_tprocs_rearrange_ip_f(spec_elem_t *s, spec_elem_t *x, spec_tproc_data_t tproc_data, int *displs, int *counts, int n, int *procs);

/* sp_type spec_tprocs_dup_f spec_tprocs_dup_count_f spec_tprocs_dup_rearrange_db_f spec_tprocs_dup_rearrange_ip_f */
typedef int spec_tprocs_dup_f(spec_elem_buf_t b, spec_elem_index_t x, spec_tproc_data_t tproc_data, int *procs, spec_elem_buf_t dups);
typedef void spec_tprocs_dup_count_f(spec_elem_t *s, spec_tproc_data_t tproc_data, int *procs, int *counts);
typedef void spec_tprocs_dup_rearrange_db_f(spec_elem_t *s, spec_elem_t *d, spec_tproc_data_t tproc_data, int *displs, int *procs, spec_elem_t *dups);
typedef void spec_tprocs_dup_rearrange_ip_f(spec_elem_t *s, spec_elem_t *x, spec_tproc_data_t tproc_data, int *displs, int *counts, int n, int *procs, spec_elem_t *dups);

/* sp_type spec_tproc_reset_f */
typedef void spec_tproc_reset_f(spec_tproc_data_t tproc_data);


#endif /* __SPEC_PUBLIC_H__ */
